#
# $Id: __Initializable.pm 9 2005-06-06 09:30:16Z manu $
#

package __Initializable;

=pod

=head1 Copyright Notice

 Copyright I.N.R.A. - C.N.R.S. 

 emmanuel.courcelle@toulouse.inra.fr
 jerome.gouzy@toulouse.inra.fr

 This software is a perl module whose purpose is to help you writing 
 your own scripts

 This software is governed by the CeCILL  license under French law and
 abiding by the rules of distribution of free software.  You can  use, 
 modify and/ or redistribute the software under the terms of the CeCILL
 license as circulated by CEA, CNRS and INRIA at the following URL
 http://www.cecill.info" 

 As a counterpart to the access to the source code and  rights to copy,
 modify and redistribute granted by the license, users are provided only
 with a limited warranty  and the software's author,  the holder of the
 economic rights,  and the successive licensors  have only  limited
 liability. 

 In this respect, the user's attention is drawn to the risks associated
 with loading,  using,  modifying and/or developing or reproducing the
 software by the user in light of its specific status of free software,
 that may mean  that it is complicated to manipulate,  and  that  also
 therefore means  that it is reserved for developers  and  experienced
 professionals having in-depth computer knowledge. Users are therefore
 encouraged to load and test the software's suitability as regards their
 requirements in conditions enabling the security of their systems and/or 
 data to be ensured and,  more generally, to use and operate it in the 
 same conditions as regards security. 

 The fact that you are presently reading this means that you have had
 knowledge of the CeCILL license and that you accept its terms.

=head1 NAME

__Initializable - Every object should derive from this class

This class is useful ONLY to provide the new method. new calls __Init, thus initializing the stuff for the derived classes.

=cut

use strict;
use warnings;

BEGIN
{
    our $VERSION = do {my @r = (q$Rev: 9 $ =~ /\d+/g); $r[0]};
}

sub New
{
    my ($class, @args) = @_;

    #print "KOUKOU $class\n";
    my $self = bless {}, ref($class) || $class;
    $self->__Init(@args);
    return $self;
}

1;

